// Browse.cpp : implementation file
//

#include "stdafx.h"
#include "credguic.h"
#include "Browse.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBrowse dialog


CBrowse::CBrowse(CWnd* pParent /*=NULL*/)
	: CDialog(CBrowse::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBrowse)
	m_account1 = _T("");
	m_account2 = _T("");
	m_account3 = _T("");
	m_account4 = _T("");
	m_amount1 = _T("");
	m_amount2 = _T("");
	m_amount3 = _T("");
	m_amount4 = _T("");
	m_name1 = _T("");
	m_name2 = _T("");
	m_name3 = _T("");
	m_name4 = _T("");
	m_errormsg = _T("");
	m_errormsg2 = _T("");
	m_errormsg3 = _T("");
	//}}AFX_DATA_INIT
}


void CBrowse::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBrowse)
	DDX_Text(pDX, IDC_ACCOUNT1, m_account1);
	DDV_MaxChars(pDX, m_account1, 6);
	DDX_Text(pDX, IDC_ACCOUNT2, m_account2);
	DDV_MaxChars(pDX, m_account2, 6);
	DDX_Text(pDX, IDC_ACCOUNT3, m_account3);
	DDV_MaxChars(pDX, m_account3, 6);
	DDX_Text(pDX, IDC_ACCOUNT4, m_account4);
	DDV_MaxChars(pDX, m_account4, 6);
	DDX_Text(pDX, IDC_AMOUNT1, m_amount1);
	DDV_MaxChars(pDX, m_amount1, 8);
	DDX_Text(pDX, IDC_AMOUNT2, m_amount2);
	DDV_MaxChars(pDX, m_amount2, 8);
	DDX_Text(pDX, IDC_AMOUNT3, m_amount3);
	DDV_MaxChars(pDX, m_amount3, 8);
	DDX_Text(pDX, IDC_AMOUNT4, m_amount4);
	DDV_MaxChars(pDX, m_amount4, 8);
	DDX_Text(pDX, IDC_NAME1, m_name1);
	DDV_MaxChars(pDX, m_name1, 20);
	DDX_Text(pDX, IDC_NAME2, m_name2);
	DDV_MaxChars(pDX, m_name2, 20);
	DDX_Text(pDX, IDC_NAME3, m_name3);
	DDV_MaxChars(pDX, m_name3, 20);
	DDX_Text(pDX, IDC_NAME4, m_name4);
	DDV_MaxChars(pDX, m_name4, 20);
	DDX_Text(pDX, IDC_ERRMSG, m_errormsg);
	DDV_MaxChars(pDX, m_errormsg, 50);
	DDX_Text(pDX, IDC_ERRMSG2, m_errormsg2);
	DDV_MaxChars(pDX, m_errormsg2, 50);
	DDX_Text(pDX, IDC_ERRMSG3, m_errormsg3);
	DDV_MaxChars(pDX, m_errormsg3, 50);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CBrowse, CDialog)
	//{{AFX_MSG_MAP(CBrowse)
	ON_BN_CLICKED(IDC_BACK, OnBack)
	ON_BN_CLICKED(IDC_FORWARD, OnForward)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBrowse message handlers

void CBrowse::OnBack() 
{
	// TODO: Add your control notification handler code here
	performBrowse('B');
}

void CBrowse::OnForward() 
{
	// TODO: Add your control notification handler code here
	performBrowse('F');
}

BOOL CBrowse::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	// Perform the initial browse operation
    int RC = ca.executeStartBrowse(init_acctno);

	getResults(RC);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CBrowse::performBrowse(const char brType)
{
	// Execute the CICS transaction
	int RC = ca.executeBrowseNext(brType);

	getResults(RC);
    
	// Display the results
	this->UpdateData(FALSE);
}

void CBrowse::getResults(int RC)
{
	// Make sure our data variables are updated first
	this->UpdateData(TRUE);

	if (RC == 0)
	{
		m_account1 = ca.br_account1;
		m_account2 = ca.br_account2;
		m_account3 = ca.br_account3;
		m_account4 = ca.br_account4;
		m_name1    = ca.br_name1;
		m_name2    = ca.br_name2;
		m_name3    = ca.br_name3;
		m_name4    = ca.br_name4;
		m_amount1  = ca.br_amount1;
		m_amount2  = ca.br_amount2;
		m_amount3  = ca.br_amount3;
		m_amount4  = ca.br_amount4;
		m_errormsg  = ca.co_errormsg;
		m_errormsg2 = ca.co_errormsg2;
		m_errormsg3 = ca.co_errormsg3;
	}
	else
	{
		// Get a pointer to the main application object
		CCredguicApp* myApp = (CCredguicApp*) AfxGetApp();

		m_errormsg = myApp->cics_message;
	}
 
	// Display the results
	this->UpdateData(FALSE);
}
